package a0b36pr2_du2.rychly_balik.gui;

import a0b36pr2_du2.rychly_balik.model.RychlyBalikDataService;
import a0b36pr2_du2.rychly_balik.model.RychlyBalikException;
import a0b36pr2_du2.rychly_balik.model.doprava.Dodavka;
import a0b36pr2_du2.rychly_balik.model.doprava.Doprava;
import a0b36pr2_du2.rychly_balik.model.doprava.Doprava.TypDopravy;
import a0b36pr2_du2.rychly_balik.model.doprava.Kolo;
import a0b36pr2_du2.rychly_balik.model.doprava.Mhd;
import a0b36pr2_du2.rychly_balik.model.doprava.PickUp;
import java.awt.Frame;
import java.awt.event.*;
import java.util.Arrays;
import javax.swing.ButtonGroup;
import javax.swing.ComboBoxModel;
import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.event.ListDataListener;

public class EditDopravaJDialog extends EditJdialog {

    JLabel typDoprProstredkuLabel;
    JLabel nosnostLabel;
    JLabel rychlostLabel;
    JTextField nosnostTextField;
    JTextField rychlostTextField;
    JComboBox typDopravyComboBox;
    JButton saveButton;
    JButton cancelButton;

    public EditDopravaJDialog(RychlyBalikGui parent, boolean modal, RychlyBalikDataService dataModel) {
        super(parent, modal, dataModel);
    }

    protected void createGui() {
        typDoprProstredkuLabel = new JLabel("Typ:");
        nosnostLabel = new JLabel("Nosnost:");
        rychlostLabel = new JLabel("Rychlost:");
        nosnostTextField = new JTextField();
        rychlostTextField = new JTextField();

        TypDopravy[] doparavaValues =
                new TypDopravy[TypDopravy.values().length + 1];
        int i = 1;
        for (TypDopravy typ : TypDopravy.values()) {
            doparavaValues[i] = typ;
        }
        typDopravyComboBox =
                new JComboBox(new javax.swing.DefaultComboBoxModel(TypDopravy.
                values()));
        nastavEditovatelnost();
        saveButton = new JButton("Uložit");
        cancelButton = new JButton("Zrušit");

        GroupLayout layout = new GroupLayout(getContentPane());
        getContentPane().setLayout(layout);

        layout.setAutoCreateGaps(true);
        layout.setAutoCreateContainerGaps(true);

        layout.setVerticalGroup(layout.createSequentialGroup().addGroup(layout.
                createParallelGroup().addComponent(typDoprProstredkuLabel).
                addComponent(typDopravyComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)).
                addGroup(layout.createParallelGroup().addComponent(nosnostLabel).
                addComponent(nosnostTextField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)).
                addGroup(layout.createParallelGroup().addComponent(rychlostLabel).
                addComponent(rychlostTextField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)).
                addGroup(layout.createParallelGroup().addComponent(typDoprProstredkuLabel).
                addComponent(typDopravyComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)).
                addGroup(layout.createParallelGroup().addComponent(saveButton).
                addComponent(cancelButton)));

        layout.setHorizontalGroup(layout.createParallelGroup().addGroup(layout.
                createSequentialGroup().addComponent(typDoprProstredkuLabel).
                addComponent(typDopravyComboBox, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)).
                addGroup(layout.createSequentialGroup().addComponent(nosnostLabel).
                addComponent(nosnostTextField)).addGroup(layout.
                createSequentialGroup().addComponent(rychlostLabel).addComponent(rychlostTextField)).
                addGroup(layout.createSequentialGroup().addComponent(typDoprProstredkuLabel).
                addComponent(typDopravyComboBox)).addGroup(layout.
                createSequentialGroup().
                addComponent(saveButton).addComponent(cancelButton)));

        typDopravyComboBox.addItemListener(new ItemListener() {

            public void itemStateChanged(ItemEvent e) {
                nastavEditovatelnost();
            }
        });

        saveButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                save(e);
            }
        });

        cancelButton.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                cancel(e);
            }
        });
        this.setSize(300, 300);
    }

    protected void saveToObject(java.awt.event.ActionEvent evt) throws RychlyBalikException {
        double rychlost = 0;
        double nosnost = 0;
        try {
            rychlost = Double.parseDouble(rychlostTextField.getText());
            nosnost = Double.parseDouble(nosnostTextField.getText());
        } catch (NumberFormatException e) {
            throw new RychlyBalikException("Rychlost a nosnost musi byt cisla.");
        }
        TypDopravy typDopravy =
                (TypDopravy) typDopravyComboBox.getSelectedItem();
        Doprava doprava = null;

        switch (typDopravy) {
            case DODAVKA:
                doprava = new Dodavka();
                break;
            case KOLO:
                doprava = new Kolo(nosnost, rychlost);
                break;
            case MHD:
                doprava = new Mhd(nosnost);
                break;
            case PickUp:
                doprava = new PickUp(nosnost);
                break;
            default:
                throw new RychlyBalikException("Nebyla vybran zadny typ dopravy.");
        }
        dataModel.pridejDopravniProstredek(doprava);
        parentGui.aktualizujVozovyParkGui();
    }

    private void nastavEditovatelnost() {
        nosnostTextField.setText("");
        rychlostTextField.setText("");
        TypDopravy typDopravy =
                (TypDopravy) typDopravyComboBox.getSelectedItem();
        nosnostTextField.setEditable(typDopravy.isNosnostEditable());
        rychlostTextField.setEditable(typDopravy.isRychlostEditable());
        switch (typDopravy) {
            case DODAVKA:
                nosnostTextField.setText(Double.toString(Dodavka.NOSNOST));
                rychlostTextField.setText(Double.toString(Dodavka.RYCHLOST));
                break;
            case MHD:
                rychlostTextField.setText(Double.toString(Mhd.RYCHLOST));
                break;
            case PickUp:
                rychlostTextField.setText(Double.toString(PickUp.RYCHLOST));
                break;
        }
    }
}
