/*
 * EditZasilkaJDialog.java
 *
 * Created on 21.3.2010, 14:37:12
 */
package a0b36pr2_du2.rychly_balik.gui;

import a0b36pr2_du2.rychly_balik.model.RychlyBalikDataService;
import a0b36pr2_du2.rychly_balik.model.RychlyBalikException;
import a0b36pr2_du2.rychly_balik.model.Zasilka;
import a0b36pr2_du2.rychly_balik.model.personalistika.VykonnyPracovnik;
import java.util.List;
import javax.swing.DefaultComboBoxModel;

/**
 *
 * @author hapallen
 */
public class EditZasilkaJDialog extends EditJdialog {

    private javax.swing.JButton saveButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JComboBox pracovnikComboBox;
    private javax.swing.JLabel hmotnostLabel;
    private javax.swing.JLabel vzdalenostLabel;
    private javax.swing.JLabel dodalLabel;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;

    public EditZasilkaJDialog(RychlyBalikGui parent, boolean modal, RychlyBalikDataService dataModel) {
        super(parent, modal, dataModel);
    }

    protected void createGui() {

        hmotnostLabel = new javax.swing.JLabel();
        vzdalenostLabel = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jTextField2 = new javax.swing.JTextField();
        saveButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        pracovnikComboBox = new javax.swing.JComboBox();
        dodalLabel = new javax.swing.JLabel();

        hmotnostLabel.setText("Hmotnost:");
        vzdalenostLabel.setText("Vzdálenost:");
        saveButton.setText("Uložit");
        saveButton.addActionListener(new java.awt.event.ActionListener() {

            public void actionPerformed(java.awt.event.ActionEvent evt) {
                save(evt);
            }
        });

        cancelButton.setText("Zrušit");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {

            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancel(evt);
            }
        });

        pracovnikComboBox.setModel(new javax.swing.DefaultComboBoxModel(dataModel.
                getSmena().getSeznamVykonnychPracovniku().toArray()));

        dodalLabel.setText("Dodal:");

        javax.swing.GroupLayout layout =
                new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).
                addGroup(layout.createSequentialGroup().addGroup(layout.
                createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).
                addGroup(layout.createSequentialGroup().addGap(30, 30, 30).
                addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING).
                addComponent(vzdalenostLabel).addComponent(hmotnostLabel).
                addComponent(dodalLabel)).addGap(18, 18, 18).addGroup(layout.
                createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false).
                addComponent(jTextField2).addComponent(jTextField1, javax.swing.GroupLayout.DEFAULT_SIZE, 103, Short.MAX_VALUE).
                addComponent(pracovnikComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))).
                addGroup(layout.createSequentialGroup().addGap(81, 81, 81).
                addComponent(saveButton).addGap(74, 74, 74).addComponent(cancelButton))).
                addContainerGap(127, Short.MAX_VALUE)));
        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING).
                addGroup(layout.createSequentialGroup().addGap(36, 36, 36).
                addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).
                addComponent(hmotnostLabel).addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)).
                addGap(18, 18, 18).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).
                addComponent(vzdalenostLabel).addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)).
                addGap(18, 18, 18).addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).
                addComponent(pracovnikComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE).
                addComponent(dodalLabel)).addGap(36, 36, 36).addGroup(layout.
                createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE).
                addComponent(saveButton).addComponent(cancelButton)).
                addContainerGap(109, Short.MAX_VALUE)));

        pack();
    }

    protected void saveToObject(java.awt.event.ActionEvent evt) throws RychlyBalikException {
        double hmotnost = 0;
        double vzdalenost = 0;

        try {
            hmotnost = Double.parseDouble(jTextField1.getText().trim());
            vzdalenost = Double.parseDouble(jTextField2.getText().trim());
        } catch (NumberFormatException e) {
            throw new RychlyBalikException("Pole hmotnost nebo vzdalenost musi obsahovat ciselnou hodnotu.");
        }

        VykonnyPracovnik pracovnik = (VykonnyPracovnik) pracovnikComboBox.
                getModel().getSelectedItem();
        Zasilka zasilka = new Zasilka(hmotnost, vzdalenost, pracovnik);
        if (!dataModel.isPracovnikSchopenDorucit(zasilka, pracovnik)) {
            throw new RychlyBalikException("Pracovnik neni schopen dorucit zasilku, protoze ji neunese.");
        }
        dataModel.pridejZasilku(zasilka);
        parentGui.aktualizujZasilkyGui();
        this.dispose();
    }

    class PracovniciComboBoxModel extends DefaultComboBoxModel {
    }
}
