/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.gui;

import a0b36pr2_du2.rychly_balik.model.RychlyBalikDataService;
import a0b36pr2_du2.rychly_balik.model.RychlyBalikException;
import a0b36pr2_du2.rychly_balik.model.Zasilka;
import a0b36pr2_du2.rychly_balik.model.doprava.Doprava;
import a0b36pr2_du2.rychly_balik.model.personalistika.Pracovnik;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;

/**
 *
 * @author hapallen
 */
public class RychlyBalikGui extends JFrame {

    public enum Zalozka {

        ZASILKY("Zásilky"), VOZOVY_PARK("Vozový park"), SMENA("Pracovníci");
        private String name;

        private Zalozka(String name) {
            this.name = name;
        }

        @Override
        public String toString() {
            return this.name;
        }

        public static Zalozka getZalozkaByName(String name) {
            if (name.equals(Zalozka.SMENA.name)) {
                return Zalozka.SMENA;
            }
            if (name.equals(Zalozka.VOZOVY_PARK.name)) {
                return Zalozka.VOZOVY_PARK;
            }
            if (name.equals(Zalozka.ZASILKY.name)) {
                return Zalozka.ZASILKY;
            }
            return null;
        }
    }
    //prehled pracovniku
    //prehled vozoveho parku
    // prehled zasilek
    //formular pro pridani/editaci noveho pracovnika
    //formular zadani zasilky
    //formular pro pridani dopravniho prostredku
    RychlyBalikDataService dataModel;
    JMenuBar mainMenuBar;
    JMenu novyMenu;
    JMenuItem novaZasilkaMenuItem;
    JMenuItem novyPracovnikaMenuItem;
    JMenuItem novaDopravaMenuItem;
    JTabbedPane mainTabbedPane;
    JButton smazatButton;
    JList zasilkyJList;
    JList pracovniciJList;
    JList vozovyParkJList;
    JScrollPane zasilkyScrollPane;
    JScrollPane vozovyParkScrollPane;
    JScrollPane pracovniciScrollPane;

    public RychlyBalikGui() {
        this(new RychlyBalikDataService());
    }

    public RychlyBalikGui(RychlyBalikDataService rychlyBalikData) {
        this.dataModel = rychlyBalikData;
        //nutne, aby se pri vypnuti okna vypla i aplikace
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        //nastaveni velkosti
        this.setSize(new Dimension(800, 600));
        this.setMinimumSize(new Dimension(800, 600));
        dataModel.loadData();
        createGui();
        pack();
    }

    public void createGui() {
        mainMenuBar = new javax.swing.JMenuBar();
        novyMenu = new javax.swing.JMenu();
        novaZasilkaMenuItem = new javax.swing.JMenuItem();
        novyPracovnikaMenuItem = new javax.swing.JMenuItem();
        novaDopravaMenuItem = new javax.swing.JMenuItem();
        novyMenu.setText("Nový...");
        smazatButton = new JButton();
        smazatButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/trash-bin.gif")));
        smazatButton.setSize(20, 20);

        novaZasilkaMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_Z, java.awt.event.InputEvent.CTRL_MASK));
        novaZasilkaMenuItem.setText("Nová zásilka");
        novaZasilkaMenuItem.setActionCommand("newZasilka");
        novyMenu.add(novaZasilkaMenuItem);

        novyPracovnikaMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_P, java.awt.event.InputEvent.CTRL_MASK));
        novyPracovnikaMenuItem.setText("Nový pracovník");
        novyMenu.add(novyPracovnikaMenuItem);

        novaDopravaMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_D, java.awt.event.InputEvent.CTRL_MASK));
        novaDopravaMenuItem.setText("Nový dopravní prostředek");
        novyMenu.add(novaDopravaMenuItem);

        mainMenuBar.add(novyMenu);
        setJMenuBar(mainMenuBar);

        mainTabbedPane = new javax.swing.JTabbedPane();


        zasilkyJList = new JList(new DefaultListModel());
        zasilkyJList.setFocusable(true);
        pracovniciJList = new JList(new DefaultListModel());
        pracovniciJList.setFocusable(true);
        vozovyParkJList = new JList(new DefaultListModel());
        vozovyParkJList.setFocusable(true);

        zasilkyScrollPane = new javax.swing.JScrollPane();
        zasilkyScrollPane.setName(Zalozka.ZASILKY.name);
        vozovyParkScrollPane = new javax.swing.JScrollPane();
        vozovyParkScrollPane.setName(Zalozka.VOZOVY_PARK.name);
        pracovniciScrollPane = new javax.swing.JScrollPane();
        pracovniciScrollPane.setName(Zalozka.SMENA.name);
        zasilkyScrollPane.setViewportView(zasilkyJList);
        pracovniciScrollPane.setViewportView(pracovniciJList);
        vozovyParkScrollPane.setViewportView(vozovyParkJList);
        mainTabbedPane.addTab(Zalozka.ZASILKY.name, zasilkyScrollPane);
        mainTabbedPane.addTab(Zalozka.SMENA.name, pracovniciScrollPane);
        mainTabbedPane.addTab(Zalozka.VOZOVY_PARK.name, vozovyParkScrollPane);


        Container container = getContentPane();
        container.add(smazatButton, BorderLayout.SOUTH);
        container.add(mainTabbedPane, BorderLayout.CENTER);

        novyPracovnikaMenuItem.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                EditPracovnikJDialog novyPracovnik =
                        new EditPracovnikJDialog(RychlyBalikGui.this, true, dataModel);
                novyPracovnik.setVisible(true);
            }
        });

        novaZasilkaMenuItem.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                EditZasilkaJDialog novaZasilkaJDialog =
                        new EditZasilkaJDialog(RychlyBalikGui.this, true, dataModel);
                novaZasilkaJDialog.setVisible(true);
            }
        });
        novaDopravaMenuItem.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                EditDopravaJDialog novaDoprava =
                        new EditDopravaJDialog(RychlyBalikGui.this, true, dataModel);
                novaDoprava.setVisible(true);
            }
        });

        smazatButton.addActionListener(new ObsluhaSmazatButton());
        aktualizujGui();
        pack();
    }

    public void aktualizujGui() {
        aktualizujPracovniciGui();
        aktualizujVozovyParkGui();
        aktualizujZasilkyGui();
    }

    protected void aktualizujPracovniciGui() {
        DefaultListModel pracovniciModel = (DefaultListModel) pracovniciJList.
                getModel();
        pracovniciModel.clear();
        for (Pracovnik p : dataModel.getSmena().getSeznamPracovniku()) {
            pracovniciModel.addElement(p);
        }
    }

    protected void aktualizujZasilkyGui() {
        DefaultListModel zasilkyModel =
                (DefaultListModel) zasilkyJList.getModel();
        zasilkyModel.clear();
        for (Zasilka z : dataModel.getSeznamZasilek()) {
            zasilkyModel.addElement(z);
        }
    }

    protected void aktualizujVozovyParkGui() {
        DefaultListModel vozovyParkModel = (DefaultListModel) vozovyParkJList.
                getModel();
        vozovyParkModel.clear();
        for (Doprava d : dataModel.getVozovyPark().getSeznam()) {
            vozovyParkModel.addElement(d);
        }
    }

    class ObsluhaSmazatButton implements ActionListener {

        public void actionPerformed(ActionEvent e) {
            if (mainTabbedPane.getSelectedComponent() instanceof JScrollPane) {
                JScrollPane scroll = (JScrollPane) mainTabbedPane.
                        getSelectedComponent();
                Zalozka zalozka = Zalozka.getZalozkaByName(scroll.getName());
                try {
                    switch (zalozka) {
                        case ZASILKY:
                            if (zasilkyJList.getSelectedIndex() != -1) {
                                DefaultListModel model = (DefaultListModel) zasilkyJList.
                                        getModel();
                                Zasilka zasilka = (Zasilka) model.getElementAt(zasilkyJList.
                                        getSelectedIndex());
                                dataModel.odeberZasilku(zasilka);
                                System.out.println("remove from zasilky  - zasilka: " + zasilka);
                            }
                            break;
                        case SMENA:
                            if (pracovniciJList.getSelectedIndex() != -1) {
                                DefaultListModel model = (DefaultListModel) pracovniciJList.
                                        getModel();
                                Pracovnik pracovnik = (Pracovnik) model.
                                        getElementAt(pracovniciJList.
                                        getSelectedIndex());
                                // model.removeElementAt(pracovniciJList.getSelectedIndex());
                                dataModel.odeberPracovnika(pracovnik);
                                System.out.println("remove from pracovnici  - pracovnik: " + pracovnik);
                            }
                            break;
                        case VOZOVY_PARK:
                            if (vozovyParkJList.getSelectedIndex() != -1) {
                                DefaultListModel model = (DefaultListModel) vozovyParkJList.
                                        getModel();
                                Doprava doprava = (Doprava) model.getElementAt(vozovyParkJList.
                                        getSelectedIndex());
                                // model.removeElementAt(pracovniciJList.getSelectedIndex());
                                dataModel.odeberDopravniProstredek(doprava);
                                System.out.println("remove from vozovy park  - doprava: " + doprava);
                            }
                            break;
                        default:
                            throw new RychlyBalikException("Nebyla vybrana zadna zalozka");
                    }

                    // odebiralo se jen z datoveho modelu a je treba ted aktualizovat gui
                    aktualizujGui();
                } catch (RychlyBalikException re) {
                    JOptionPane.showMessageDialog(null,
                            "Chyba pri mazani objektu: " + re.getMessage(), "Chyba pri odebirani ze zalozky " + zalozka, JOptionPane.ERROR_MESSAGE);
                }
            }
        }
    }
}
