/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.model;

import a0b36pr2_du2.rychly_balik.model.doprava.Riditelny;
import a0b36pr2_du2.rychly_balik.model.personalistika.Pracovnik;
import a0b36pr2_du2.rychly_balik.model.personalistika.VykonnyPracovnik;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * Vytvořte třídu směna, která bude evidovat zaměstnance na měně a bude schopna
 * určit seznam vozidel z vozového parku, která může směna obsluhovat.
 * @author hapallen
 */
public class Smena {

    private List<Pracovnik> seznamPracovniku = new ArrayList<Pracovnik>();

    public void vloz(Pracovnik p) {
        seznamPracovniku.add(p);
    }

    /**
     * odebere pracovnika ze smeny
     * @param pracovnik
     * @return odebrany pracovnik nebo null, pokud neexistuje
     * @throws RychlyBalikException pokud pracovnik ve smene neexistuje
     */
    public Pracovnik odeber(Pracovnik p) throws RychlyBalikException {
        if( seznamPracovniku.remove(p)){
           return p;
        }
        throw new RychlyBalikException("Tento pracovník ve smene neexistuje.");
    }

    public List<Pracovnik> getSeznamPracovniku() {
        return seznamPracovniku;
    }

    public void setSeznamPracovniku(List<Pracovnik> seznamPracovniku) {
        this.seznamPracovniku = seznamPracovniku;
    }


    public List<VykonnyPracovnik> getSeznamVykonnychPracovniku(){
        List<VykonnyPracovnik> pracovnici = new ArrayList<VykonnyPracovnik>();
       for (Pracovnik p : seznamPracovniku) {
            if (p instanceof VykonnyPracovnik) {
                VykonnyPracovnik vp = (VykonnyPracovnik) p;
                pracovnici.add(vp);
            }
        }
       return pracovnici;
    }

    /**
     * zjisti, jaka ridicska opravneni ma smena
     * @return
     */
    public Set<Riditelny.Opravneni> getOpravneniSmeny() {
        Set<Riditelny.Opravneni> opravneni =
                new HashSet<Riditelny.Opravneni>();
        for (VykonnyPracovnik vp : getSeznamVykonnychPracovniku()) {
                opravneni.addAll(vp.getOpravneni());            
        }
        return opravneni;
    }
}
