/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.model;

import a0b36pr2_du2.rychly_balik.model.doprava.Mhd;
import a0b36pr2_du2.rychly_balik.model.doprava.Doprava;
import a0b36pr2_du2.rychly_balik.model.doprava.PickUp;
import a0b36pr2_du2.rychly_balik.model.doprava.Dodavka;
import a0b36pr2_du2.rychly_balik.model.doprava.Kolo;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author hapallen
 */
public class VozovyPark {

    private List<Doprava> seznam = new ArrayList<Doprava>();

    /*
    Vytvořte reprezentaci vozového parku a do jedné jeho instance vložte
    velkou dodávku, dvě malé s nosnostmi 1500 a 2300 kg,
    sportovní kolo s nosností 3kg a rychlostí 35 km/hod,
    dva pěšáky s nosností 14 a 6 kg.
     */
    public static VozovyPark createVozovyPark() {
        VozovyPark vp = new VozovyPark();
        vp.vloz(new Dodavka());
        try {
        vp.vloz(new PickUp(1500));
        vp.vloz(new PickUp(2300));
        vp.vloz(new Kolo(3, 35));
        vp.vloz(new Mhd(14));
        vp.vloz(new Mhd(6));
        } catch(RychlyBalikException re){
            System.out.println("Chyba pri plneni vozoveho parku");
        }
        return vp;
    }

    public List<Doprava> getSeznam() {
        return seznam;
    }
    

    public void vloz(Doprava d) {
        seznam.add(d);
    }

    /**
     * odebere dopravní prostředek z vozového  parku
     * @param dopravniProstredek
     * @return odebraný dopravní prostředek
     * @throws RychlyBalikException pokud vozový park tento dopravní prostředek neobsahuje
     */
    public Doprava odeberDopravniProstredek(Doprava dopravniProstredek) throws RychlyBalikException{
        if(seznam.remove(dopravniProstredek)){
            return dopravniProstredek;
        }
        throw new RychlyBalikException("Vozovy park tento dopravní prostředek neobsahuje.");
    }


    public Object[] toArray() {
        return  seznam.toArray();
    }

    /**
     * Napište metodu, která pro zásilku zadanou hmotností a vzdáleností určí
     * nejlevnější dopravní prostředek, který ji samozřejmě uveze.
     * @param z
     * @return
     */
    public Doprava najdiNejvodnejsiDopravu(Zasilka z) {
        double min = Double.MAX_VALUE;
        Doprava dop = null;
        for (Doprava d : seznam) {
            if (z.jeDPPouzitelny(d) && d.getCenaZaVzdalenost(z.getVzdalenost()) < min) {
                min = d.getCenaZaVzdalenost(z.getVzdalenost());
                dop = d;
            }
        }
      return dop;
    }
}
