/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.model;

import a0b36pr2_du2.rychly_balik.model.doprava.Doprava;
import a0b36pr2_du2.rychly_balik.model.personalistika.Pracovnik;
import a0b36pr2_du2.rychly_balik.model.personalistika.VykonnyPracovnik;

/**
 *
 * @author hapallen
 */
public class Zasilka {

    private double hmotnost = 0;
    private double vzdalenost;
    private Pracovnik pracovnik;

    public Zasilka(double hmotnost, double vzdalenost) throws RychlyBalikException {
        setHmotnost(hmotnost);
        setVzdalenost(vzdalenost);
    }

   public Zasilka(double hmotnost, double vzdalenost, Pracovnik pracovnik) throws RychlyBalikException {
        this(hmotnost, vzdalenost);
        this.pracovnik = pracovnik;
    }
    public void setHmotnost(double hmotnost) throws RychlyBalikException {
         if(hmotnost <= 0.0){
            throw new RychlyBalikException("Hmotnost zasilky musi byt kladna");
        }
        this.hmotnost = hmotnost;
    }

    public void setVzdalenost(double vzdalenost) throws RychlyBalikException {
        if(vzdalenost <= 0.0){
            throw new RychlyBalikException("Vzdalenost musi byt kladna");
        }
        this.vzdalenost = vzdalenost;
    }

    public double getHmotnost() {
        return hmotnost;
    }

    public double getVzdalenost() {
        return vzdalenost;
    }

    public Pracovnik getPracovnik() {
        return pracovnik;
    }

    public VykonnyPracovnik getVykonnyPracovnik() {
        if (pracovnik instanceof VykonnyPracovnik) {
            return (VykonnyPracovnik) pracovnik;
        }
        return null;
    }

    public void setPracovnik(Pracovnik pracovnik) {
        this.pracovnik = pracovnik;
    }

    /**
     *
     * @param dopravniProstredek
     * @return true, pokud je dany dopravni prastredek pouzitelny pro doruceni teto zasilky
     */
    public boolean jeDPPouzitelny(Doprava dopravniProstredek){
         if (dopravniProstredek.getNosnost() >= hmotnost) {
             return true;
         }
         return false;
    }

    @Override
    public String toString() {
        return String.format("zasilka %10.2f kg %10.2f km %25s", getHmotnost(), getVzdalenost(), (getPracovnik() == null ? "nepřiřazeno" : getPracovnik().
                getJmenoAPrijmeni()));
    }
}
