/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.model.doprava;

import a0b36pr2_du2.rychly_balik.model.RychlyBalikException;

/**
 *KOLO, jezdí různou rychlostí dle zdatnosti cyklisty, cena je pouze variabilní
 * a to 250 Kč/hodinu. Pro řízení kola je nutné na kole umět jezdit, nosnost
 * kola dána konstruktorem a nepřesahuje 10 kg.
 * @author hapallen
 */
public class Kolo extends Doprava implements Riditelny {

    private static final double MAX_NOSNOST = 10; // nosnost v kg, ruzne kola mohou mit ruznou
    private double nosnost;
    private double rychlost;

    public Kolo(double nosnost, double rychlost) throws RychlyBalikException {
        setNosnost(nosnost);
        if (rychlost <= 0.0) {
            throw new RychlyBalikException("Rychlost musi byt kladna.");
        }
        this.rychlost = rychlost;
    }

    public void setNosnost(double nosnost) throws RychlyBalikException {
        this.nosnost = nosnost;
        if (nosnost <= 0.0) {
            throw new RychlyBalikException("Nosnost musi byt kladna.");
        }
        if (nosnost > MAX_NOSNOST) {
           throw new RychlyBalikException("Prekrocena max nosnost kola (" + MAX_NOSNOST +" kg).");
        }
    }

    public double getNosnost() {
        return nosnost;
    }

    public double getCenaZaVzdalenost(double vzdalenost) {
        return 250 * vzdalenost / rychlost;
    }

    public Opravneni getOpravneni() {
        return Opravneni.KOLO;
    }

    public void setOpravneni(Opravneni opravneni) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public String toString() {
        return String.format(TO_STRING_FORMAT, "Kolo", getNosnost(), rychlost, getCenaZaVzdalenost(1));
    }
}
