/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package a0b36pr2_du2.rychly_balik.model.doprava;

import a0b36pr2_du2.rychly_balik.model.RychlyBalikException;

/**
 *Pick-up jezdí také 40 km/hod, podle typu vozu uveze zásilky do hmotnosti až
 * 2500kg (přesná hmotnost je dána v konstruktoru) cena je 80kč + 230Kč/km a
 * pro řízení je nutné mít řidičské oprávnění skupiny C.
 * @author hapallen
 */
public class PickUp extends Doprava implements  Riditelny {

    public static final double RYCHLOST = 40; // RYCHLOST km/hod
    private static final double MAX_NOSNOST = 2500; // nosnost v kg, ruzne pickupy mohou mit ruznou
    private double nosnost;

    /**
     * konstruktor umoznuje nastavit jen max povolenou nosnost
     * @param nosnost
     */
    public PickUp(double nosnost) throws RychlyBalikException {
        setNosnost(nosnost);
    }

    public void setNosnost(double nosnost) throws RychlyBalikException {
       this.nosnost = nosnost;
       if (nosnost <= 0.0) {
            throw new RychlyBalikException("Nosnost musi byt kladna.");
        }
        if (nosnost > MAX_NOSNOST) {
             throw new RychlyBalikException("Prekrocena max nosnost pickupu (" + MAX_NOSNOST +" kg).");
        }
    }

    public double getNosnost() {
        return nosnost;
    }

    public double getCenaZaVzdalenost(double vzdalenost) {
        return 80 + 230 * vzdalenost;
    }

    public Opravneni getOpravneni() {
        return Opravneni.B;
    }

    public void setOpravneni(Opravneni opravneni) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public String toString() {
        return String.format(TO_STRING_FORMAT, "Pick-up", getNosnost(), RYCHLOST, getCenaZaVzdalenost(1)) ;
    }
}
